<template lang="html">
    <div class="md:flex md:flex-row md:flex-grow container max-w-full">
        <div class="flex-grow-0 max-w-full w-full max-h-full bg-white md:max-w-xs">
            <div class="users flex flex-col">
                <div class="pt-2 relative mx-auto text-gray-600 mb-4">
                    <input class="border-2 border-gray-300 bg-white h-10 px-5 pr-16 rounded-lg text-sm focus:outline-none" type="search" name="search" placeholder="Search" />
                    <button type="submit" class="absolute right-0 top-0 mt-5 mr-4">
                        <svg class="text-gray-600 h-4 w-4 fill-current" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" id="Capa_1" x="0px" y="0px" viewBox="0 0 56.966 56.966" style="enable-background:new 0 0 56.966 56.966;" xml:space="preserve" width="512px" height="512px">
                            <path d="M55.146,51.887L41.588,37.786c3.486-4.144,5.396-9.358,5.396-14.786c0-12.682-10.318-23-23-23s-23,10.318-23,23  s10.318,23,23,23c4.761,0,9.298-1.436,13.177-4.162l13.661,14.208c0.571,0.593,1.339,0.92,2.162,0.92  c0.779,0,1.518-0.297,2.079-0.837C56.255,54.982,56.293,53.08,55.146,51.887z M23.984,6c9.374,0,17,7.626,17,17s-7.626,17-17,17  s-17-7.626-17-17S14.61,6,23.984,6z" />
                        </svg>
                    </button>
                </div>
                <div v-if="u.id != user" class="user flex flex-row h-auto p-2 hover:bg-gray-100 cursor-pointer border-b border-gray-300" v-for="u in users" v-on:click="selected(u)" v-bind:class="{'bg-gray-200': u.id == target.id}">
                    <div class="fas fa-user-shield flex-grow-0 h-auto w-12 text-4xl"></div> 
                    <div class="flex-grow-1 h-full max-h-full max-w-full w-full ml-2">
                        <div class="name font-medium w-full"> {{u.name}} 
                            <i class="pl-2 fas fa-circle" v-bind:class="{'text-green-400': u.state == 'online', 'text-orange-400': u.state == 'away', 'text-red-400': u.state == 'busy', 'text-gray-400': u.state == 'offline'}"></i> 
                        </div>
                        <div class="role font-thin w-full text-xs">Developer</div>
                    </div>
                    <div class="text-xs bg-gray-500 text-white self-center text-center p-1 rounded-full w-12">{{u.messages.length}}</div> 
                </div>
            </div>
        </div>
        <div class="flex flex-col flex-grow max-w-full max-h-full bg-gray-400">
            <div class="flex flex-row flex-grow-0 text-center headline h-12 bg-blue-200">
                <div class="flex-grow-0 self-center text-center text-4xl p-2 text-blue-400 hover:text-blue-500 cursor-pointer md:hidden">
                    <i class="fas fa-align-justify"></i>
                </div>
                <div class="flex-grow-0 self-center text-center text-4xl p-2 text-blue-400 hover:text-blue-500 cursor-pointer" v-on:click="dial()">
                    <i class="fas fa-video"></i>
                </div>
                <div class="flex-grow-0 self-center text-center text-4xl p-2 text-blue-400 hover:text-blue-500 cursor-pointer">
                    <i class="fas fa-camera"></i>
                </div>
                <div class="flex-grow-1 self-center text-center max-w-full w-full">
                    <div class="name font-medium w-full">{{target.id != 0 ? target.name : "Nobody"}}</div>
                    <div class="role font-thin w-full text-xs">Developer</div>
                </div>
                <div class="flex-grow-0 self-center text-center fas fa-times text-4xl p-2 text-gray-600 hover:text-gray-800 cursor-pointer"></div>
            </div>
            <div class="body flex-grow-1 max-h-full h-full p-2 overflow-y-auto relative xl:flex xl:flex-row">
                <div class="conversation max-h-full h-full max-w-full w-full float-left overflow-y-auto z-10 absolute xl:relative xl:opacity-100" v-bind:class="{'invisible xl:visible': (busy && !force_chat)}" v-chat-scroll="{always: false, smooth: true}">
                    <div class="view-actions flex flex-row justify-end h-12 w-full absolute top-0 left-0">
                        <div v-if="busy" class="fixed xl:hidden flex-grow-0 self-center text-center text-2xl p-4 bg-purple-100 text-purple-600 hover:bg-purple-600 hover:text-purple-100 cursor-pointer rounded-full" v-on:click="minimize_phone(false)">
                            <i class="fas fa-phone-volume"></i>
                        </div>
                    </div>
                    <div class="messages flex flex-col h-0">
                        <div class="message flex mb-2" v-for="message in selected_messages" v-bind:class="{'self-end': message.sent}">
                            <wee-message :category="message.category" :type="message.type" :sent="message.sent" :rcvd="message.rcvd" :from="users[message.from].name" :to="users[message.to].name" :time="message.time">
                                {{message.content}}
                            </wee-message>
                        </div>
                    </div>
                </div>
                <wee-phone ref="phone" v-on:disconnect="disconnect" v-bind:class="{'invisible': !busy || (busy && force_chat)}" v-on:minimize="minimize_phone(true)"></wee-phone>
            </div>
            <div class="flex-grow-0 h-16 bg-white action relative">
                <textarea class="max-width-full w-full bg-blue-100 resize-none border rounded focus:outline-none focus:bg-teal-100 p-2 text-gray-800 text-sm" v-bind:disabled="target.id == 0" v-model="written" v-on:keyup.enter="send"></textarea>
                <div class="absolute right-0 bottom-0 max-h-full h-full p-2 cursor-pointer text-indigo-400 hover:text-indigo-500 text-4xl" v-on:click="send">
                    <i class="fas fa-paper-plane "></i>
                </div>
            </div>
        </div>
    </div>
</template>
<script type="javascript">
    import Vue from 'vue'
    import axios from 'axios'
    import axiosCancel from 'axios-cancel';
    import VueChatScroll from 'vue-chat-scroll'
    import WeeMessageComponent from './WeeMessageComponent.vue'
    import WeePhoneComponent from './WeePhoneComponent.vue'
    import { WebRTCCommunicator } from "./WebRTC.js"
    import './style.css'

    axiosCancel(axios, {
        debug: false // default
    });
    
    Vue.use(VueChatScroll)
   
    export default {
        name: "WeeChatComponent",
        props: ["user"],
        components: {
            'WeeMessage': WeeMessageComponent,
            'WeePhone': WeePhoneComponent
        },
        data: function(){
            return {
                target:   {
                    id: 0,
                    name: "nobody"
                },
                users:    {},
                messages: [],
                busy: false,
                force_chat: false,
                last: 0,
                written: "",
            }
        },
        beforeCreate: function(){
            this._urls = {
                users: "/user/ping",
                poll:  "/chat/ping",
                send:  "/chat/send"
            }
        },
        created: function(){
            console.log("WeeChatComponent loading");
            this.fetch_users();
            this.presence();
        },
        mounted: function(){
            let self = this;
            this.$nextTick(()=> {
                let phone = self.$refs.phone;
                self._conn = new WebRTCCommunicator({
                    local: self.$refs.phone.local(),
                    remote: self.$refs.phone.remote(),
                    extractor: self.extract,
                    transmitter: self.transmit,
                    ringer: self.ring
                });
                self._conn.onconnected = function(){
                    self.connected();
                };
                self._conn.ondisconnected = function(){
                    self.disconnected();
                };
            });
        },
        methods: {
            sync_users: function(){
                let self = this;
                console.log("WeeChatComponent syncing users");
                axios.post(this._urls.users+"/1", {
                    busy: this.busy
                }, {requestId: "sync_users"}).then(function(response){
                    for(let user of response.data.users){
                        if(!(user.id in self.users)){
                            user.messages = [];
                            self.$set(self.users, user.id, user);
                        }else{
                            if(self.users[user.id].state != user.state){
                                self.users[user.id].state = user.state;
                            }
                            self.users[user.id].seen = user.seen;
                        }
                    }
                    console.log(self.users);
                    self.sync_users();
                }).catch((thrown) => {});
            },
            fetch_users: function(){
                let self = this;
                console.log("WeeChatComponent loading users");
                axios.post(this._urls.users+"/0", {
                    busy: this.busy
                }).then(function(response){
                    for(let user of response.data.users){
                        if(!(user.id in self.users)){
                            user.messages = [];
                            self.$set(self.users, user.id, user);
                        }else{
                            if(self.users[user.id].state != user.state){
                                self.users[user.id].state = user.state;
                            }
                            self.users[user.id].seen = user.seen;
                        }
                    }
                    console.log(self.users);
                    self.sync_users();
                }); 
            },
            presence: function(){
                console.log("WeeChatComponent ping");
                let self = this;
                axios.get(this._urls.poll+"/"+this.last).then(function(response){
                    console.log(response.data.messages);
                    for(const message of response.data.messages){
                        let related_user = message.from == self.user ? message.to : message.from;
                        message.sent = message.from == self.user;
                        message.rcvd = message.from != self.user;
                        if(related_user in self.users){
                            self.users[related_user].messages.push(message);
                            if(message.category == "personal/control"){
                                console.log("control message");
                                self.control(message);
                            }
                        }
                    }
                    if(response.data.messages.length > 0){
                        const max = response.data.messages.reduce((l,r) => l.id > r.id ? l : r).id;
                        self.last = Math.max(self.last, max);
                    }
                    self.presence();
                });
            },
            selected: function(user){
                this.target = user;
                this._conn.to = user.id;
            },
            send: function(){
                let self = this;
                axios.post(this._urls.send, {
                    "from": this.user,
                    "to": this.target.id,
                    "content": this.written,
                    "type": "text/plain",
                    "category": "personal/data",
                    "time": new Date()
                }).then(function(response){
                    self.written = "";
                    console.log(response);
                });
            },
            dial: function(){
                this.busy = true;
                this._conn.dial();
                this.$refs.phone.dial(this.target);
                axios.cancel("sync_users");
                this.sync_users();
            },
            control: function(message){
                if(message.rcvd){
                    console.log("control forwarding");
                    this._conn.rcvd(message);
                }
            },
            extract: function(message){
                if(message.rcvd && message.category == "personal/control"){
                    const then = new Date(message.time);
                    const now  = new Date();
                    const diff = (now.getTime() - then.getTime());
                    const seconds = Math.floor(diff / 1000);
                    const content = JSON.parse(message.content);
                    console.log("control message age ", seconds);
                    if(content.topic && content.topic == "webrtc"){
                        return seconds < 60 ? content : false;
                    }
                }
                console.log("control ignoring not personal/control");
                return false;
            },
            transmit: function(packet){
                axios.post(this._urls.send, {
                    "from": this.user,
                    "to": this.target.id,
                    "content": JSON.stringify(packet),
                    "type": "text/json",
                    "category": "personal/control",
                    "time": new Date()
                }).then(function(response){
                    console.log(response);
                });
            },
            ring: function(message, on_accept, on_reject){
                this.busy = true;
                let user = this.users[message.from];
                let self = this;
                this.$refs.phone.ring(user);
                this.$refs.phone.$off('accepted');
                this.$refs.phone.$off('rejected');
                this.$refs.phone.$on('accepted', function(){
                    on_accept();
                    self.$refs.phone.$off('accepted');
                    self.$refs.phone.$off('rejected');
                    self.$refs.phone.$on('rejected', function(){
                        self.disconnect();
                    });
                });
                this.$refs.phone.$on('rejected', function(){
                    self.busy = false;
                    on_reject();
                    
                    axios.cancel("sync_users");
                    self.sync_users();
                });
                
                axios.cancel("sync_users");
                self.sync_users();
            },
            connected: function(){
                console.log("chat: peers are now connected");
                this.$refs.phone.connected();
            },
            disconnect: function(){
                console.log("caught disconnect from chat");
                this._conn.disconnect();
                this.disconnected();
            },
            disconnected: function(){
                this.$refs.phone.disconnected();
                this.busy = false;
                axios.cancel("sync_users");
                this.sync_users();
            },
            minimize_phone: function(state){
                console.log("minimize called");
                this.force_chat = state;
            }
        },
        computed: {
            selected_messages: function(){
                if(this.target.id == 0){
                    return [];
                }
                return this.users[this.target.id].messages;
            }
        }
    }
</script>
<style lang="css" scoped>

</style>
